#!/system/bin/sh
# Relljawa
# give credit if you use any part!!
# telegram dev @reljawa
# based on Morpheus Ai

# Waiting for boot completed
while [ "$(getprop sys.boot_completed | tr -d '\r')" != "1" ]; do sleep 3; done

# Path
MODDIR=${0%/*}

# Device online functions
wait_until_login()
{
    # whether in lock screen, tested on Android 7.1 & 10.0
    # in case of other magisk module remounting /data as RW
    while [ "$(dumpsys window policy | grep mInputRestricted=true)" != "" ]; do
        sleep 2
    done
    # we doesn't have the permission to rw "/sdcard" before the user unlocks the screen
    while [ ! -d "/sdcard/Android" ]; do
        sleep 2
    done
    }
read_file(){
  if [[ -f $1 ]]; then
    if [[ ! -r $1 ]]; then
      chmod +r "$1"
    fi
    cat "$1"
  else
    echo "File $1 not found"
  fi
}
write(){
  if [[ -f $1 ]]; then
    if [[ ! -w $1 ]]; then
      chmod +w "$1"
    fi
    echo "$2" > $1
    chmod +r "$1"
  else
    echo "File $1 not found"
  fi
}
# Device online
wait_until_login 

# Enable all tweak
sed -Ei 's/^description=(\[.*][[:space:]]*)?/description=[ 📢 Apply optimization please wait... ] /g' "$MODDIR/module.prop"
su -lp 2000 -c "cmd notification post -S bigtext -t 'Performance Tweak-Ai' tag '📢 Apply optimization please wait...'" >/dev/null 2>&1

# Sync to data in the rare case a device crashes
sync

for cpu_cache_path in /sys/bus/cpu/devices/cpu*/cache/index*/type; do
    cache_type=$(read_file $cpu_cache_path)

    if [ "$cache_type" == "Instruction" ] || [ "$cache_type" == "Data" ]; then
        cpu_cache_dir=$(dirname $cpu_cache_path)
        shared_cpu_map_path="$cpu_cache_dir/shared_cpu_map"
        shared_cpu_list_path="$cpu_cache_dir/shared_cpu_list"
        # Menulis ke shared_cpu_map_path
        write "$shared_cpu_map_path" "0xff"
        # Menulis ke shared_cpu_list_path
        write "$shared_cpu_list_path" "0-7"
    fi
done

# optimizing I/O
write "/sys/block/sda/queue/iosched/slice_idle" "0"

write "/dev/cpuset/memory_spread_slab" "1"
echo "1" > /dev/cpuset/top-app/sched_relax_domain_level

write "/proc/sys/kernel/random/write_wakeup_threshold" "500"

# Set the thread siblings list to "0xff" for each CPU device's topology
for thread_siblings in $(find /sys/bus/cpu/devices/ -name thread_siblings); do
    write "$thread_siblingsx" "0xff"
done

# disable sched overide for top-app and opt
write "/dev/stune/top-app/schedtune.sched_boost_no_override" "0"
write "/dev/cpuset/top-app/memory_migrate" "1"
write "/dev/cpuset/top-app/memory_spread_page" "1"

# better sched and kernel
write "/dev/stune/rt/schedtune.colocate" "1"
write "/dev/stune/top-app/schedtune.boost" "80"

# Done
sleep 10
sed -Ei 's/^description=(\[.*][[:space:]]*)?/description=[ 🎉 All optimization is applied... ] /g' "$MODDIR/module.prop"
su -lp 2000 -c "cmd notification post -S bigtext -t 'Performance Tweak' tag '🎉 All optimization is applied...'" >/dev/null 2>&1

# Exec Morpheus Ai Function Tweak
nohup sh $MODDIR/script/morpheus.sh &&
process_output=$(pgrep -f "$MODDIR/script/morpheus.sh")
chrt -i -p $process_output 0

exit 0